package com.jcg.autoclose;

/**
 * @author Santosh Balgar Sachchidananda
 * TryWithResourcesAndFinallyBlock demonstrates how an AutoCLoseable resource works when there is a finally block
 */

public class TryWithResourcesAndFinallyBlock {
    public static void main(String[] args) {
        try (MyCustomAutoCloseable myCustomAutoCloseable = new MyCustomAutoCloseable()) {
            System.out.println("****** Executing try block ******");
            myCustomAutoCloseable.printHello();
        } catch (Exception ex) {
            System.out.println("****** Executing catch block ******");
        } finally {
            System.out.println("****** Executing finally block ******");
        }
    }
}

/**
 * MyCustomeAutoCloseable is an Auto Closeable resource that implements AutoCloseable interface
 */

class MyCustomAutoCloseable implements AutoCloseable {

    @Override
    public void close() throws Exception {
        System.out.println("******* MyCustomAutoCloseable close() method *******");
    }

    public void printHello() {
        System.out.println("******* Hello!! I am MyCustomAutoCloseable, an AutoCloseable resource *******");
    }

}
