package com.jgc.main;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;

public class TryCatchSample {

    private static void printFile() throws Exception{
        FileInputStream input = null;
        try {
            input = new FileInputStream("file.txt");
            int data = input.read();
            while (data != -1) {
                System.out.print((char) data);
                data = input.read();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            input.close();
        }
    }

    private static void printFileJava7() throws IOException {

        try (FileInputStream input = new FileInputStream("file.txt")) {

            int data = input.read();
            while (data != -1) {
                System.out.print((char) data);
                data = input.read();
            }
        }
    }

    private static void myAutoClosable() throws Exception {

        try (MyAutoClosable myAutoClosable = new MyAutoClosable()) {
            myAutoClosable.doIt();
        }
    }

    private static void printFileJava7MultiResources() throws IOException {
        try (FileInputStream input = new FileInputStream("file.txt");
             BufferedInputStream bufferedInput = new BufferedInputStream(input)) {
            int data = bufferedInput.read();
            while (data != -1) {
                System.out.print((char) data);
                data = bufferedInput.read();
            }
        }
    }
}
